/*
 * MathPlanner 3.0 - Mathematical design tool.
 * Copyright(C) 2002  Jarmo Nikkanen
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation.
 *
 * You should have received a copy of the GNU General Public License with this program.
 *
 */

#include "MathHeaders.h"
#include <malloc.h>

math_node mpl_neg(math_node a)
{
        math_node ans;

        /*
        if (a.Count()) {
        		ans.SetCount(a.Count());
						for(i=0;i<Count();i++) ans.SetNode(i,mpl_neg(a.Node(i)));
        } */

        ans.type=a.type;
        if (a.type==MN_REAL) ans.R=-a.R;
				if (a.type==MN_COMPLEX) ans.R=-a.R, ans.I=-a.I;
				if (a.type==MN_RATIONAL) ans.R=-a.R, ans.I=a.I;
				if (a.type==MN_VECTOR) ans.I=-a.I, ans.J=-a.J, ans.K=-a.K;

return(ans);
}


math_node mpl_add(math_node a,math_node b)
{
        math_node ans;
        ans.type=MN_NULL;

        if (a.type==MN_REAL) {
               if (b.type==MN_REAL) ans.R=a.R+b.R, ans.type=MN_REAL;
               if (b.type==MN_COMPLEX) ans.R=a.R+b.R, ans.I=b.I, ans.type=MN_COMPLEX;
               if (b.type==MN_RATIONAL) ans.R=a.R*b.I+b.R, ans.I=b.I, ans.type=MN_RATIONAL;
        }

        if (a.type==MN_COMPLEX) {
               if (b.type==MN_REAL) ans.R=a.R+b.R, ans.I=a.I, ans.type=MN_COMPLEX;
               if (b.type==MN_COMPLEX) ans.R=a.R+b.R, ans.I=a.I+b.I, ans.type=MN_COMPLEX;
               if (b.type==MN_RATIONAL) ans.R=a.R+(b.R/b.I), ans.I=a.I, ans.type=MN_COMPLEX;
        }

        if (a.type==MN_RATIONAL) {
               if (b.type==MN_RATIONAL) ans.R=a.R*b.I+a.I*b.R, ans.I=a.I*b.I, ans.type=MN_RATIONAL;
               if (b.type==MN_COMPLEX) ans.R=(a.R/a.I)+b.R, ans.I=b.I, ans.type=MN_COMPLEX;
               if (b.type==MN_REAL) ans.R=a.R+a.I*b.R, ans.I=a.I, ans.type=MN_RATIONAL;
        }

        if (a.type==MN_VECTOR) {
               if (b.type==MN_VECTOR) ans.I=a.I+b.I, ans.J=a.J+b.J, ans.K=a.K+b.K, ans.type=MN_VECTOR;
        }

        return(ans);
}


math_node mpl_sub(math_node a,math_node b)
{
        math_node ans;
        ans.type=MN_NULL;

        if (a.type==MN_REAL) {
               if (b.type==MN_REAL) ans.R=a.R-b.R, ans.type=MN_REAL;
               if (b.type==MN_COMPLEX) ans.R=a.R-b.R, ans.I=0-b.I, ans.type=MN_COMPLEX;
               if (b.type==MN_RATIONAL) ans.R=a.R*b.I-b.R, ans.I=b.I, ans.type=MN_RATIONAL;
        }

        if (a.type==MN_COMPLEX) {
               if (b.type==MN_REAL) ans.R=a.R-b.R, ans.I=a.I, ans.type=MN_COMPLEX;
               if (b.type==MN_COMPLEX) ans.R=a.R-b.R, ans.I=a.I-b.I, ans.type=MN_COMPLEX;
               if (b.type==MN_RATIONAL) ans.R=a.R-(b.R/b.I), ans.I=a.I, ans.type=MN_COMPLEX;
        }

        if (a.type==MN_RATIONAL) {
               if (b.type==MN_RATIONAL) ans.R=a.R*b.I-a.I*b.R, ans.I=a.I*b.I, ans.type=MN_RATIONAL;
               if (b.type==MN_COMPLEX) ans.R=(a.R/a.I)-b.R, ans.I=0-b.I, ans.type=MN_COMPLEX;
               if (b.type==MN_REAL) ans.R=a.R-a.I*b.R, ans.I=a.I, ans.type=MN_RATIONAL;
        }

        if (a.type==MN_VECTOR) {
               if (b.type==MN_VECTOR) ans.I=a.I-b.I, ans.J=a.J-b.J, ans.K=a.K-b.K, ans.type=MN_VECTOR;
        }

        return(ans);
}

math_node mpl_mul(math_node a,math_node b)
{
        math_node ans;
        ans.type=MN_NULL;

        if (a.type==MN_REAL) {
               if (b.type==MN_REAL) ans.R=a.R*b.R, ans.type=MN_REAL;
               if (b.type==MN_COMPLEX) ans.R=a.R*b.R, ans.I=a.R*b.I, ans.type=MN_COMPLEX;
               if (b.type==MN_RATIONAL) ans.R=a.R*b.R, ans.I=b.I, ans.type=MN_RATIONAL;
               if (b.type==MN_VECTOR) ans.I=a.R*b.I, ans.J=a.R*b.J, ans.K=a.R*b.K, ans.type=MN_VECTOR;
        }

        if (a.type==MN_COMPLEX) {
               if (b.type==MN_REAL) ans.R=a.R*b.R, ans.I=a.I*b.R, ans.type=MN_COMPLEX;
               if (b.type==MN_COMPLEX) ans.R=a.R*b.R-a.I*b.I, ans.I=a.R*b.I+a.I*b.R, ans.type=MN_COMPLEX;
               if (b.type==MN_RATIONAL) ans.R=a.R*(b.R/b.I), ans.I=a.I*(b.R/b.I), ans.type=MN_COMPLEX;
        }

        if (a.type==MN_RATIONAL) {
               if (b.type==MN_RATIONAL) ans.R=a.R*b.R, ans.I=a.I*b.I, ans.type=MN_RATIONAL;
               if (b.type==MN_COMPLEX) ans.R=b.R*(a.R/a.I), ans.I=b.I*(a.R/a.I), ans.type=MN_COMPLEX;
               if (b.type==MN_REAL) ans.R=a.R*b.R, ans.I=a.I, ans.type=MN_RATIONAL;
               if (b.type==MN_VECTOR) ans.I=(a.R/a.I)*b.I, ans.J=(a.R/a.I)*b.J, ans.K=(a.R/a.I)*b.K, ans.type=MN_VECTOR;
        }

        if (a.type==MN_VECTOR) {  // Dot product
               if (b.type==MN_VECTOR) ans.R=a.I*b.I+a.J*b.J+a.K*b.K, ans.type=MN_REAL;
               if (b.type==MN_REAL) ans.I=a.I*b.R, ans.J=a.J*b.R, ans.K=a.K*b.R, ans.type=MN_VECTOR;
               if (b.type==MN_RATIONAL) ans.I=(b.R/b.I)*a.I, ans.J=(b.R/b.I)*a.J, ans.K=(b.R/b.I)*a.K, ans.type=MN_VECTOR;
        }

        return(ans);
}

math_node mpl_div(math_node a,math_node b)
{
        math_node ans,opz;
        ans.type=MN_NULL;

        if (a.type==MN_REAL) {
               if (b.type==MN_REAL) ans.R=a.R/b.R, ans.type=MN_REAL; // ok
               if (b.type==MN_COMPLEX) { opz=mpl_opz(b.Complex()); ans.R=a.R*opz.R, ans.I=a.R*opz.I, ans.type=MN_COMPLEX; }
               if (b.type==MN_RATIONAL) ans.R=a.R*b.I, ans.I=b.R, ans.type=MN_RATIONAL;
               if (b.type==MN_VECTOR) ans.I=a.R/b.I, ans.J=a.R/b.J, ans.K=a.R/b.K, ans.type=MN_VECTOR;
        }

        if (a.type==MN_COMPLEX) {
               if (b.type==MN_REAL) ans.R=a.R*(1/b.R), ans.I=a.I*(1/b.R), ans.type=MN_COMPLEX;
               if (b.type==MN_COMPLEX) { opz=mpl_opz(b.Complex()); ans.R=a.R*opz.R-a.I*opz.I, ans.I=a.R*opz.I+a.I*opz.R, ans.type=MN_COMPLEX; }
               if (b.type==MN_RATIONAL) ans.R=a.R*(b.I/b.R), ans.I=a.I*(b.I/b.R), ans.type=MN_COMPLEX;
        }

        if (a.type==MN_RATIONAL) {
               if (b.type==MN_RATIONAL) ans.R=a.R*b.I, ans.I=a.I*b.R, ans.type=MN_RATIONAL;
               if (b.type==MN_COMPLEX) ans.R=b.R*(a.I/a.R), ans.I=b.I*(a.I/a.R), ans.type=MN_COMPLEX;
               if (b.type==MN_REAL) ans.R=a.R, ans.I=a.I*b.R, ans.type=MN_RATIONAL;
               if (b.type==MN_VECTOR) ans.I=(a.I/a.R)*b.I, ans.J=(a.I/a.R)*b.J, ans.K=(a.I/a.R)*b.K, ans.type=MN_VECTOR;
        }

        if (a.type==MN_VECTOR) {
               if (b.type==MN_VECTOR) ans.I=a.I/b.I, ans.J=a.J/b.J, ans.K=a.K/b.K, ans.type=MN_VECTOR;
               if (b.type==MN_REAL) ans.I=a.I/b.R, ans.J=a.J/b.R, ans.K=a.K/b.R, ans.type=MN_VECTOR;
               if (b.type==MN_RATIONAL) ans.I=(b.I/b.R)*a.I, ans.J=(b.I/b.R)*a.J, ans.K=(b.I/b.R)*a.K, ans.type=MN_VECTOR;
        }

        return(ans);
}


math_node::math_node()
{
sub=NULL; count=0;
Clear();
}

math_node::~math_node()
{
sub=NULL; count=0;
}

math_node::math_node(double r)
{
sub=NULL; count=0;
R=r; type=MN_REAL;
}

math_node::math_node(mpl_complex z)
{
sub=NULL; count=0;
R=z.r; I=z.i; type=MN_COMPLEX;
}

math_node::math_node(mpl_rational r)
{
sub=NULL; count=0;
R=r.a; I=r.b; type=MN_RATIONAL;
}


math_node::math_node(mpl_vector v)
{
sub=NULL; count=0;
R=0; I=v.i; J=v.j; K=v.k; type=MN_VECTOR;
}


bool math_node::SetCount(int no)
{
    if (sub) free(sub);
		sub=(math_node *)malloc(no*sizeof(math_node));
    if (sub) {
        count=no;
        return(true);
    }
    return(false);
}

int math_node::Count()
{
		return(count);
}

void math_node::SetNode(int id,math_node mn)
{
		if (id<count && sub) sub[id]=mn;
}

math_node math_node::Node(int id)
{	
    if (id<count && sub) return(sub[id]);
    math_node n;
    return(n);
}

void math_node::Clear()
{
R=I=K=J=0.0;
type=MN_REAL;
}

bool math_node::isNull()
{
if (type==MN_NULL) return(true);
return(false);
}

void math_node::SetReal(double x)
{
R=x;
type=MN_REAL;
}

void math_node::SetComplex(mpl_complex z)
{
R=z.r; I=z.i;
type=MN_COMPLEX;
}

void math_node::SetRational(mpl_rational r)
{
R=r.a; I=r.b;
type=MN_RATIONAL;
}

double math_node::Real()
{
    if (type==MN_RATIONAL) return(R/I);
    return(R);
}

mpl_complex math_node::Complex()
{
    mpl_complex z;
    if (type==MN_REAL) I=0;
    z.r=R; z.i=I;
    return(z);
}

mpl_rational math_node::Rational()
{
    mpl_rational z;
    z.a=R; z.b=I;
    return(z);
}

mpl_vector math_node::Vector()
{
    mpl_vector z;
    z.i=I; z.j=J; z.k=K;
    return(z);
}



