/*
 * MathPlanner 3.0.5 - Mathematical design tool.
 * Copyright(C) 2002  Jarmo Nikkanen
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation.
 *
 * You should have received a copy of the GNU General Public License with this program.
 *
 */




PaperImage::PaperImage(DataStorage *msg,ApplicationControl *a,Paper *p)
:MathFrame(msg,a,p)
{
	  Enable(true,true,false);
  	SetColor(QColor(0,0,255));
  	empty=false; 	

  	QByteArray ba=msg->ReadQByteArray("image");
  	pixmap=ImageDragObject::Decode(ba,"image/png"); 				
}


DataStorage *PaperImage::BuildStorage()
{
    DataStorage *msg=MathFrame::BuildStorage();

    ImageDragObject ido(pixmap);
    msg->AddQByteArray("image",ido.encodedData("image/png"));

  	return(msg);
}

const QImage PaperImage::Pixmap()
{
  	return(pixmap);
}


PaperImage::PaperImage(QImage b,ApplicationControl *a,Paper *p)
:MathFrame(PAPER_OBJECT_IMAGE,b.rect(),a,p)
{
   	Enable(true,true,false);
  	SetColor(QColor(0,0,255));
  	empty=false;
  	pixmap=b.copy();
}


void PaperImage::SetBounds(QRect r)
{	
	   MathFrame::SetBounds(bounds);
}

void PaperImage::CalculateBounds()
{
        MathFrame::CalculateBounds();
        resizerect.setSize(QSize(10,10));
        resizerect.moveBottomRight(bounds.bottomRight());
}


void PaperImage::MousePressed(QPoint p)
{

}

void PaperImage::Draw(QPainter *paint)
{
        paint->drawImage(bounds.topLeft(),pixmap);
        MathFrame::Draw(paint);
}
	
	
	
	
	




