/*
 * MathPlanner 3.0 - Mathematical design tool.
 * Copyright(C) 2002  Jarmo Nikkanen
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation.
 *
 * You should have received a copy of the GNU General Public License with this program.
 *
 */

#include <qsimplerichtext.h>

PaperText::~PaperText()
{

}


PaperText::PaperText(DataStorage *msg,ApplicationControl *a,Paper *p)
:MathFrame(msg,a,p)
{
	  Enable(true,true,false);
  	SetColor(QColor(0,0,255));
  	text=msg->ReadQString("text");
  	empty=false;		
}


DataStorage *PaperText::BuildStorage()
{
    DataStorage *msg=MathFrame::BuildStorage();
    msg->AddQString("text",text);
  	return(msg);
}

const QString PaperText::Text()
{
  	return(text);
}


PaperText::PaperText(QString b,ApplicationControl *a,Paper *p)
:MathFrame(PAPER_OBJECT_TEXT,QRect(0,0,150,50),a,p)
{
   	Enable(true,true,false);
  	SetColor(QColor(0,0,255));
  	empty=false;
  	text=b; //.replace(QRegExp("\n"),"<br>");

}


void PaperText::SetBounds(QRect r)
{	
	MathFrame::SetBounds(r);
	view=bounds;
	view.setLeft(view.left()+10);
	view.setTop(view.top()+10);
	view.setRight(view.right()-10);
	view.setBottom(view.bottom()-10);
}

void PaperText::CalculateBounds()
{
  MathFrame::CalculateBounds();
  resizerect.setSize(QSize(10,10));
  resizerect.moveBottomRight(bounds.bottomRight());
  view=bounds;
  view.setLeft(view.left()+10);
	view.setTop(view.top()+10);
	view.setRight(view.right()-10);
	view.setBottom(view.bottom()-10);
}

void PaperText::MousePressed(QPoint p)
{

}

void PaperText::Draw(QPainter *paint)
{

        QFont font;

        CalculateBounds();

        QSimpleRichText  rich(text,font);
        rich.setWidth(paint,view.width());

        const QColorGroup palette; //(Qt::black,Qt::white);
        const QRegion reg(view);

        int zoom=AppControl->ZoomFactor();

        QRect vi;
        vi.setLeft(view.left()*zoom/100);
        vi.setRight(view.right()*zoom/100);
        vi.setTop(view.top()*zoom/100);
        vi.setBottom(view.bottom()*zoom/100);

        paint->save();
        paint->setClipRect(vi);

        rich.draw(paint,view.left(),view.top(),reg,palette);

	      paint->restore();
	
        MathFrame::Draw(paint);
}
	
	
	
	
	




